ExtendedSSLSession (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: javax.net.ssl, class: ExtendedSSLSession
Keywords: javax.net.ssl.ExtendedSSLSession class

# Class ExtendedSSLSession

java.lang.Object
javax.net.ssl.ExtendedSSLSession

All Implemented Interfaces:
  `SSLSession`

public abstract class ExtendedSSLSession extends Object implements SSLSession
Extends the `SSLSession` interface to support additional session attributes.

Since:
  1.7

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ExtendedSSLSession()`
  Constructor for subclasses to call.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `byte[]`
  `exportKeyingMaterialData(String label, byte[] context, int length)`
  Generates Exported Keying Material (EKM) calculated according to the algorithms defined in RFCs 5705/8446.
  `SecretKey`
  `exportKeyingMaterialKey(String keyAlg, String label, byte[] context, int length)`
  Generates Exported Keying Material (EKM) calculated according to the algorithms defined in RFCs 5705/8446.
  `abstract String[]`
  `getLocalSupportedSignatureAlgorithms()`
  Obtains an array of supported signature algorithms that the local side is willing to use.
  `abstract String[]`
  `getPeerSupportedSignatureAlgorithms()`
  Obtains an array of supported signature algorithms that the peer is able to use.
  `List<SNIServerName>`
  `getRequestedServerNames()`
  Obtains a `List` containing all `SNIServerName`s of the requested Server Name Indication (SNI) extension.
  `List<byte[]>`
  `getStatusResponses()`
  Returns a `List` containing DER-encoded OCSP responses (using the ASN.1 type OCSPResponse defined in RFC 6960) for the client to verify status of the server's certificate during handshaking.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

  ### Methods declared in interface SSLSession

  `getApplicationBufferSize, getCipherSuite, getCreationTime, getId, getLastAccessedTime, getLocalCertificates, getLocalPrincipal, getPacketBufferSize, getPeerCertificateChain, getPeerCertificates, getPeerHost, getPeerPort, getPeerPrincipal, getProtocol, getSessionContext, getValue, getValueNames, invalidate, isValid, putValue, removeValue`
  Modifier and Type
  Method
  Description
  `int`
  `getApplicationBufferSize()`
  Gets the current size of the largest application data that is expected when using this session.
  `String`
  `getCipherSuite()`
  Returns the name of the SSL cipher suite which is used for all connections in the session.
  `long`
  `getCreationTime()`
  Returns the time at which this Session representation was created, in milliseconds since midnight, January 1, 1970 UTC.
  `byte[]`
  `getId()`
  Returns the identifier assigned to this Session.
  `long`
  `getLastAccessedTime()`
  Returns the last time this Session representation was accessed by the session level infrastructure, in milliseconds since midnight, January 1, 1970 UTC.
  `Certificate[]`
  `getLocalCertificates()`
  Returns the certificate(s) that were sent to the peer during handshaking.
  `Principal`
  `getLocalPrincipal()`
  Returns the principal that was sent to the peer during handshaking.
  `int`
  `getPacketBufferSize()`
  Gets the current size of the largest SSL/TLS/DTLS packet that is expected when using this session.
  `default X509Certificate[]`
  `getPeerCertificateChain()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  The `SSLSession.getPeerCertificates()` method that returns an array of `java.security.cert.Certificate` should be used instead.
  `Certificate[]`
  `getPeerCertificates()`
  Returns the identity of the peer which was established as part of defining the session.
  `String`
  `getPeerHost()`
  Returns the host name of the peer in this session.
  `int`
  `getPeerPort()`
  Returns the port number of the peer in this session.
  `Principal`
  `getPeerPrincipal()`
  Returns the identity of the peer which was established as part of defining the session.
  `String`
  `getProtocol()`
  Returns the standard name of the protocol used for all connections in the session.
  `SSLSessionContext`
  `getSessionContext()`
  Returns the context in which this session is bound.
  `Object`
  `getValue(String name)`
  Returns the object bound to the given name in the session's application layer data.
  `String[]`
  `getValueNames()`
  Returns an array of the names of all the application layer data objects bound into the Session.
  `void`
  `invalidate()`
  Invalidates the session.
  `boolean`
  `isValid()`
  Returns whether this session is valid and available for resuming or joining.
  `void`
  `putValue(String name, Object value)`
  Binds the specified `value` object into the session's application layer data with the given `name`.
  `void`
  `removeValue(String name)`
  Removes the object bound to the given name in the session's application layer data.

- ## Constructor Details

  - ### ExtendedSSLSession

    public ExtendedSSLSession()
    Constructor for subclasses to call.

- ## Method Details

  - ### getLocalSupportedSignatureAlgorithms

    public abstract String[] getLocalSupportedSignatureAlgorithms()
    Obtains an array of supported signature algorithms that the local side is willing to use.

    Note: this method is used to indicate to the peer which signature algorithms may be used for digital signatures in TLS/DTLS 1.2. It is not meaningful for TLS/DTLS versions prior to 1.2.

    The signature algorithm name must be a standard Java Security name (such as "SHA1withRSA", "SHA256withECDSA", and so on). See the Java Security Standard Algorithm Names document for information about standard algorithm names.

    Note: the local supported signature algorithms should conform to the algorithm constraints specified by `getAlgorithmConstraints()` method in `SSLParameters`.

    Returns:
      An array of supported signature algorithms, in descending order of preference. The return value is an empty array if no signature algorithm is supported.
    External Specifications
      - Java Security Standard Algorithm Names
    See Also:
      - `SSLParameters.getAlgorithmConstraints()`

  - ### getPeerSupportedSignatureAlgorithms

    public abstract String[] getPeerSupportedSignatureAlgorithms()
    Obtains an array of supported signature algorithms that the peer is able to use.

    Note: this method is used to indicate to the local side which signature algorithms may be used for digital signatures in TLS/DTLS 1.2. It is not meaningful for TLS/DTLS versions prior to 1.2.

    The signature algorithm name must be a standard Java Security name (such as "SHA1withRSA", "SHA256withECDSA", and so on). See the Java Security Standard Algorithm Names document for information about standard algorithm names.

    Returns:
      An array of supported signature algorithms, in descending order of preference. The return value is an empty array if the peer has not sent the supported signature algorithms.
    External Specifications
      - Java Security Standard Algorithm Names
    See Also:
      - `X509KeyManager`
      - `X509ExtendedKeyManager`

  - ### getRequestedServerNames

    public List<SNIServerName> getRequestedServerNames()
    Obtains a `List` containing all `SNIServerName`s of the requested Server Name Indication (SNI) extension.

    In server mode, unless the return `List` is empty, the server should use the requested server names to guide its selection of an appropriate authentication certificate, and/or other aspects of security policy.

    In client mode, unless the return `List` is empty, the client should use the requested server names to guide its endpoint identification of the peer's identity, and/or other aspects of security policy.

    Returns:
      a non-null immutable list of `SNIServerName`s of the requested server name indications. The returned list may be empty if no server name indications were requested.
    Throws:
      `UnsupportedOperationException` - if the underlying provider does not implement the operation
    Since:
      1.8
    See Also:
      - `SNIServerName`
      - `X509ExtendedTrustManager`
      - `X509ExtendedKeyManager`

  - ### getStatusResponses

    public List<byte[]> getStatusResponses()
    Returns a `List` containing DER-encoded OCSP responses (using the ASN.1 type OCSPResponse defined in RFC 6960) for the client to verify status of the server's certificate during handshaking.

    This method only applies to certificate-based server authentication. An `X509ExtendedTrustManager` will use the returned value for server certificate validation.

    Implementation Requirements:
      This method throws UnsupportedOperationException by default. Classes derived from ExtendedSSLSession must implement this method.
    Returns:
      a non-null unmodifiable list of byte arrays, each entry containing a DER-encoded OCSP response (using the ASN.1 type OCSPResponse defined in RFC 6960). The order of the responses must match the order of the certificates presented by the server in its Certificate message (See `SSLSession.getLocalCertificates()` for server mode, and `SSLSession.getPeerCertificates()` for client mode). It is possible that fewer response entries may be returned than the number of presented certificates. If an entry in the list is a zero-length byte array, it should be treated by the caller as if the OCSP entry for the corresponding certificate is missing. The returned list may be empty if no OCSP responses were presented during handshaking or if OCSP stapling is not supported by either endpoint for this handshake.
    Throws:
      `UnsupportedOperationException` - if the underlying provider does not implement the operation
    Since:
      9
    See Also:
      - `X509ExtendedTrustManager`

  - ### exportKeyingMaterialKey

    public SecretKey exportKeyingMaterialKey(String keyAlg, String label, byte[] context, int length) throws SSLKeyException
    Generates Exported Keying Material (EKM) calculated according to the algorithms defined in RFCs 5705/8446.

    RFC 5705 (for (D)TLSv1.2 and earlier) calculates different EKM values depending on whether `context` is null or non-null/empty. RFC 8446 (TLSv1.3) treats a null context as non-null/empty.

    `label` will be converted to bytes using the `StandardCharsets.UTF_8` character encoding.

    Implementation Requirements:
      The default implementation throws `UnsupportedOperationException`.
    Parameters:
      `keyAlg` - the algorithm of the resultant `SecretKey` object. See the SecretKey Algorithms section in the Java Security Standard Algorithm Names Specification for information about standard secret key algorithm names.
      `label` - the label bytes used in the EKM calculation. `label` will be converted to a `byte[]` before the operation begins.
      `context` - the context bytes used in the EKM calculation, or null
      `length` - the number of bytes of EKM material needed
    Returns:
      a `SecretKey` that contains `length` bytes of the EKM material
    Throws:
      `SSLKeyException` - if the key cannot be generated
      `IllegalArgumentException` - if `keyAlg` is empty, `length` is non-positive, or if the `label` or `context` length can not be accommodated
      `NullPointerException` - if `keyAlg` or `label` is null
      `IllegalStateException` - if this session does not have the necessary key generation material (for example, a session under construction during handshaking)
      `UnsupportedOperationException` - if the underlying provider does not implement the operation
    Since:
      25
    External Specifications
      - RFC 5705: Keying Material Exporters for Transport Layer Security (TLS)
      - RFC 8446: The Transport Layer Security (TLS) Protocol Version 1.3

  - ### exportKeyingMaterialData

    public byte[] exportKeyingMaterialData(String label, byte[] context, int length) throws SSLKeyException
    Generates Exported Keying Material (EKM) calculated according to the algorithms defined in RFCs 5705/8446.

    RFC 5705 (for (D)TLSv1.2 and earlier) calculates different EKM values depending on whether `context` is null or non-null/empty. RFC 8446 (TLSv1.3) treats a null context as non-null/empty.

    `label` will be converted to bytes using the `StandardCharsets.UTF_8` character encoding.

    Depending on the chosen underlying key derivation mechanism, the raw bytes might not be extractable/exportable. In such cases, the `exportKeyingMaterialKey(String, String, byte[], int)` method should be used instead to access the generated key material.

    Implementation Requirements:
      The default implementation throws `UnsupportedOperationException`.
    Parameters:
      `label` - the label bytes used in the EKM calculation. `label` will be converted to a `byte[]` before the operation begins.
      `context` - the context bytes used in the EKM calculation, or null
      `length` - the number of bytes of EKM material needed
    Returns:
      a byte array of size `length` that contains the EKM material
    Throws:
      `SSLKeyException` - if the key cannot be generated
      `IllegalArgumentException` - if `length` is non-positive, or if the `label` or `context` length can not be accommodated
      `NullPointerException` - if `label` is null
      `IllegalStateException` - if this session does not have the necessary key generation material (for example, a session under construction during handshaking)
      `UnsupportedOperationException` - if the underlying provider does not implement the operation, or if the derived keying material is not extractable
    Since:
      25
    External Specifications
      - RFC 5705: Keying Material Exporters for Transport Layer Security (TLS)
      - RFC 8446: The Transport Layer Security (TLS) Protocol Version 1.3